library app;

import 'models.dart';
import 'package:web_ui/web_ui.dart';
import 'package:lawndart/lawndart.dart';
import 'dart:json' as json;
import 'dart:async';
import 'package:web_ui/observe.dart' as autogenerated;

final List<TodoItem> todoItems = toObservable(new List<TodoItem>());

bool __$initialized = false;
Object __obs$initialized;
bool get initialized {
  if (autogenerated.observeReads) {
    __obs$initialized = autogenerated.notifyRead(__obs$initialized);
  }
  return __$initialized;
}
set initialized(bool value) {
  if (__obs$initialized != null && __$initialized != value) {
    __obs$initialized = autogenerated.notifyWrite(__obs$initialized);
  }
  __$initialized = value;
}

Store db = new IndexedDbAdapter("simple-todo", 'todos');

init() {
  db.open()
    .then((_) => db.getByKey("todos"))
    .then((todosString) {
      if (todosString != null) {
        var list = (json.parse(todosString) as List).map((t) => new TodoItem.fromMap(t));
        todoItems.addAll(list);
      }
      
      initialized = true;
      
      var stop = watch(() => todoItems, (e) {
        storeAllTodos();
      });
    });
}

storeAllTodos() {
  db.save(json.stringify(todoItems), "todos");
}
//@ sourceMappingURL=app.dart.map